#include <bits/stdc++.h>

using namespace std;

int main()
{
     int n, m, i=0, j=0;
    long long int c=0;

    cin>>n>>m;

    int b[m+1], a[n+1];

    b[0] = 0;

    for(i=1; i<=m; i++)
    {
        cin>>b[i];
    }

    for(i=0; i<=n; i++)
    {
        a[i]=i;
    }

        cin>>c;

    for(i=0; i<=n-m; i++)
    {
        for(j=1; j<=m; j++)
        {
            a[i + b[j]] = a[i + j];
        }
    }

    long long int brojac = 0;

    for(long long k=n; k>0; k--)
    {
        brojac = (((a[k] + brojac) % 998244353) * (c % 998244353)) % 998244353;
    }
    cout<<brojac<<endl;
    return 0;
}